#ifndef _PCIE9757_DEVICE_
#define _PCIE9757_DEVICE_
//#################### ADӲPCIE9757_PARA_AD #####################
// ADʵӲ
typedef struct _PCIE9757_PARA_AD     
{
	LONG bChannelArray[4];	// ͨѡУֱ4ͨ=TRUEʾͨ򲻲
	LONG InputRange[4];		// ģѡУֱ4ͨ
	LONG Gains[4];			// , ֱ4ͨ
	LONG Frequency;         // ɼƵ, λΪHz, [1, 800000]
	LONG TriggerMode;		// ģʽѡ
	LONG TriggerSource;		// Դѡ
	LONG TriggerType;		// ѡ(ش/崥)
	LONG TriggerDir;		// ѡ(/򴥷)
	LONG TrigLevelVolt;		// ƽ(10000mV)
	LONG TrigWindow;		// [1, 65535], λ25
	LONG ClockSource;		// ʱԴѡ(/ʱԴ)
} PCIE9757_PARA_AD, *PPCIE9757_PARA_AD;

//***********************************************************
// ADӲPCIE9757_PARA_ADеInputRange[x]ģ뷶Χʹõѡ
const long PCIE9757_INPUT_N10000_P10000mV	= 0x00; // 10000mV
const long PCIE9757_INPUT_N5000_P5000mV		= 0x01; // 5000mV
const long PCIE9757_INPUT_N2500_P2500mV		= 0x02; // 2500mV
const long PCIE9757_INPUT_0_P10000mV		= 0x03; // 010000mV
const long PCIE9757_INPUT_0_P5000mV			= 0x04; // 05000mV

//***********************************************************
// ADPCIE9757_PARA_ADеGains[x]ʹõӲѡ
const long PCIE9757_GAINS_1MULT				= 0x00; // 1
const long PCIE9757_GAINS_2MULT				= 0x01; // 2
const long PCIE9757_GAINS_4MULT				= 0x02; // 4
const long PCIE9757_GAINS_8MULT				= 0x03; // 8

//***********************************************************
// ADӲPCIE9757_PARA_ADеTriggerModeԱʹôģʽѡ
const long PCIE9757_TRIGMODE_SOFT			= 0x00; // ڴ
const long PCIE9757_TRIGMODE_POST			= 0x01; // Ӳ󴥷

//***********************************************************
// ADӲPCIE9757_PARA_ADеTriggerSourceԴźʹõѡ
const long PCIE9757_TRIGSRC_ATR				= 0x00; // ѡⲿATRԴ
const long PCIE9757_TRIGSRC_DTR				= 0x01; // ѡⲿDTRԴ
const long PCIE9757_TRIGSRC_PCI_TRIG0		= 0x02; // CONVST_INźŴԴ

// ADӲPCIE9757_PARA_ADеTriggerTypeʹõѡ
const long PCIE9757_TRIGTYPE_EDGE			= 0x00; // ش
const long PCIE9757_TRIGTYPE_PULSE			= 0x01; // 崥(ƽ)

//***********************************************************
// ADӲPCIE9757_PARA_ADеTriggerDirʹõѡ
const long PCIE9757_TRIGDIR_NEGATIVE		= 0x00; // 򴥷(/½ش)
const long PCIE9757_TRIGDIR_POSITIVE		= 0x01; // 򴥷(/ش)
const long PCIE9757_TRIGDIR_POSIT_NEGAT		= 0x02; // 򴥷(//½ش)

//***********************************************************
// ADӲPCIE9757_PARA_ADеClockSourceʱԴʹõѡ
const long PCIE9757_CLOCKSRC_IN				= 0x00; // ڲʱ
const long PCIE9757_CLOCKSRC_OUT			= 0x01; // ⲿʱ

//*************************************************************************************
// ADʵӲ
typedef struct _PCIE9757_STATUS_AD     
{
	LONG bNotEmpty;			// FIFO洢ķǿձ־=TRUEǿգ = FALSE 
	LONG bHalf;				// FIFO洢İ־=TRUEϣ = FALSE 
	LONG bDynamic_Overflow; // FIFO洢Ķ̬־= TRUEѷ = FALSEδ
	LONG bStatic_Overflow;  // FIFO洢ľ̬־= TRUEѷ = FALSEδ
	LONG bTriggerFlag;		// ־, =TRUEʾ¼=FALSEʾ¼δ
} PCIE9757_STATUS_AD, *PPCIE9757_STATUS_AD;

const int MAX_SEGMENT_COUNT = 64;
typedef struct _PCIE9757_STATUS_DMA     
{
	LONG iCurSegmentID;								// ǰλID,ʾDMAڴĻ
	LONG bSegmentSts[MAX_SEGMENT_COUNT];			// ¾״̬,=1ʾӦΪ,Ϊ
	LONG bBufferOverflow;							// ״̬
} PCIE9757_STATUS_DMA, *PPCIE9757_STATUS_DMA;

//***********************************************************
// ûӿ
#ifndef _PCIE9757_DRIVER_
#define DEVAPI __declspec(dllimport)
#else
#define DEVAPI __declspec(dllexport)
#endif

#ifdef __cplusplus
extern "C" {
#endif
	//######################## 豸 ##############################
	HANDLE DEVAPI FAR PASCAL PCIE9757_CreateDevice(int DeviceLgcID = 0);     // ߼Ŵ豸
	int DEVAPI FAR PASCAL PCIE9757_GetDeviceCount(HANDLE hDevice); // ȡ豸̨
	BOOL DEVAPI FAR PASCAL PCIE9757_ListDeviceDlg(HANDLE hDevice); // ԶԻ巽ʽбϵͳееĸPCI豸
    BOOL DEVAPI FAR PASCAL PCIE9757_ReleaseDevice(HANDLE hDevice); // ͷ豸

	//####################### ADݶȡ #################################
	// ڴͨûЩӿ򵥡ݡɿû֪豸
	// Ͳ㸴ӵӲЭͷƱ̣ĳʼ豸Ͷȡ
	// ADɸЧʵָ١ݲɼ
	BOOL DEVAPI FAR PASCAL PCIE9757_ADCalibration(			// 豸У׼.		
										HANDLE hDevice);	// 豸

	// ADѯʽ
	BOOL DEVAPI FAR PASCAL PCIE9757_InitDeviceProAD(		// ʼ豸TRUE,豸׼.
									HANDLE hDevice,			// 豸,CreateDevice
									PPCIE9757_PARA_AD pADPara); // Ӳ, ڴ˺оӲ״̬

    BOOL DEVAPI FAR PASCAL PCIE9757_StartDeviceProAD(		// ڳʼ֮豸
									HANDLE hDevice);		// 豸,CreateDevice

	BOOL DEVAPI FAR PASCAL PCIE9757_ReadDeviceProAD_Npt(	// AD־Чʱô˺ȡ豸ϵAD(ǿշʽ)
									HANDLE hDevice,			// 豸,CreateDevice
									LONG ADBuffer[],		// ԭʼADݵû
									LONG nReadSizeWords,	// ƫƵݳ()
									PLONG nRetSizeWords);   // ʵʶȡĳ()

	BOOL DEVAPI FAR PASCAL PCIE9757_GetDevStatusProAD(		// ADȡ豸ĸ״̬,ֵʾǷɹ
									HANDLE hDevice,			// 豸,CreateDevice
									PPCIE9757_STATUS_AD pADStatus); // ADĸϢṹ

	BOOL DEVAPI FAR PASCAL PCIE9757_ReadDeviceProAD_Half(	// AD־Чʱô˺ȡ豸ϵAD(ʽ)
									HANDLE hDevice,			// 豸,CreateDevice
									LONG ADBuffer[],		// ԭʼADݵû
									LONG nReadSizeWords,	// ƫλݳ()
									PLONG nRetSizeWords);	// ʵʶȡĳ()
		
    BOOL DEVAPI FAR PASCAL PCIE9757_StopDeviceProAD(		// 豸֮ͣ豸
									HANDLE hDevice);		// 豸,CreateDevice

	BOOL DEVAPI FAR PASCAL PCIE9757_ReleaseDeviceProAD(		// رAD豸,ֹ,ͷԴ
									HANDLE hDevice);		// 豸,CreateDevice

	//##################### ADݶȡ(жϷʽ)(ϲû) ###########################
	BOOL DEVAPI FAR PASCAL PCIE9757_InitDeviceIntAD(
									HANDLE hDevice, 
									HANDLE hEvent, 
									ULONG nFifoHalfLength, 
									PPCIE9757_PARA_AD pPara);

    BOOL DEVAPI FAR PASCAL PCIE9757_StartDeviceIntAD(		// ڳʼ֮豸
									HANDLE hDevice);		// 豸

	DWORD DEVAPI FAR PASCAL PCIE9757_ReadDeviceIntAD(
									HANDLE hDevice,        // 豸
									PLONG pADBuffer,       // ڽԭʼADݵû								
									LONG nReadSizeWords,   // ݳ()
									PLONG nRetSizeWords);  // شʵʳ()  
	
    BOOL DEVAPI FAR PASCAL PCIE9757_StopDeviceIntAD(			// ڿʼADɼֹͣ豸
									HANDLE hDevice);		// 豸

	BOOL DEVAPI FAR PASCAL PCIE9757_ReleaseDeviceIntAD(HANDLE hDevice);

	//##################### ADݶȡ(DMAʽ)(ϲû) ###########################
	// ADֱڴ(DMA)ʽ
	BOOL DEVAPI FAR PASCAL PCIE9757_InitDeviceDmaAD(		// ʼ豸TRUE,豸׼.
									HANDLE hDevice,			// 豸,CreateDevice
									HANDLE hDmaEvent,		// DMA¼,CreateSystemEvent
									LONG ADBuffer[],		// û,Ϊά
									LONG nReadSizeWords,	// ÿDMAʱ,ûָӦȡʵʳ(ҪСڻnSegmentSizeWords)
									LONG nSegmentCount,		// ֶε,ȡֵΧΪ2-128
									LONG nSegmentSizeWords,	// ֶεĶγ(FIFO)
									PPCIE9757_PARA_AD pADPara);// Ӳ, ڴ˺оӲ״̬

    BOOL DEVAPI FAR PASCAL PCIE9757_StartDeviceDmaAD(		// ڳʼ֮豸
									HANDLE hDevice);		// 豸,CreateDevice

	BOOL DEVAPI FAR PASCAL PCIE9757_GetDevStatusDmaAD(		// ADȡDMAй״̬,ֵʾǷɹ
									HANDLE hDevice,			// 豸,CreateDevice
									PPCIE9757_STATUS_DMA pDMAStatus); // õDMA״̬

	BOOL DEVAPI FAR PASCAL PCIE9757_SetDevStatusDmaAD(		// ADDMAй״̬,ֵʾǷɹ
									HANDLE hDevice,			// 豸,CreateDevice
									LONG iClrBufferID);		// ҪĻID,Ϊ0
		
    BOOL DEVAPI FAR PASCAL PCIE9757_StopDeviceDmaAD(		// 豸֮ͣ豸
									HANDLE hDevice);		// 豸,CreateDevice

	BOOL DEVAPI FAR PASCAL PCIE9757_ReleaseDeviceDmaAD(		// رAD豸,ֹ,ͷԴ
									HANDLE hDevice);		// 豸,CreateDevice
	
	//##################### ADӲ ###########################
	BOOL DEVAPI FAR PASCAL PCIE9757_SaveParaAD(HANDLE hDevice, PPCIE9757_PARA_AD pADPara); // ǰADϵͳ
    BOOL DEVAPI FAR PASCAL PCIE9757_LoadParaAD(HANDLE hDevice, PPCIE9757_PARA_AD pADPara); // ADϵͳж
    BOOL DEVAPI FAR PASCAL PCIE9757_ResetParaAD(HANDLE hDevice, PPCIE9757_PARA_AD pADPara); // ADָĬֵ

	//################# ڴӳĴֱӲд ########################
	// ûԱ豸ֱӡ⡢Ͳ㡢ӵĿơ
	// ƶҪĿ̺ͿЧʱûʹЩӿʵ֡
	BOOL DEVAPI FAR PASCAL PCIE9757_GetDeviceBar(			// ȡָָ豸ĴBARַ
									HANDLE hDevice,			// 豸,CreateDevice
									__int64 pbPCIBar[6]);	// PCI BARеַ,PCI BARжٿõַ뿴Ӳ˵

    BOOL DEVAPI FAR PASCAL PCIE9757_WriteRegisterByte(		// ָĴռλд뵥
									HANDLE hDevice,			// 豸,CreateDevice
									__int64 pbLinearAddr,		// ָĴԻַ,GetDeviceAddrеpbLinearAddrֵ
									ULONG OffsetBytes,		// Իַַƫλ(ֽ)
									BYTE Value);			// ַָд뵥ֽݣַԻַƫλþ

	BOOL DEVAPI FAR PASCAL PCIE9757_WriteRegisterWord(		// д˫ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes,  
									WORD Value);

	BOOL DEVAPI FAR PASCAL PCIE9757_WriteRegisterULong(		// дĽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes,  
									ULONG Value);

	BYTE DEVAPI FAR PASCAL PCIE9757_ReadRegisterByte(		// 뵥ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes);

	WORD DEVAPI FAR PASCAL PCIE9757_ReadRegisterWord(		// ˫ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes);

	ULONG DEVAPI FAR PASCAL PCIE9757_ReadRegisterULong(		// ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes);

	//################# I/O˿ֱӲд ########################
	// ûԱ豸ֱӡ⡢Ͳ㡢ӵĿơ
	// ƶҪĿ̺ͿЧʱûʹЩӿʵ֡
	// ЩҪڴͳ豸ISAߡڡڵ豸ڱPCI豸
    BOOL DEVAPI FAR PASCAL PCIE9757_WritePortByte(			// 8λд˿
									HANDLE hDevice,			// 豸(CreateDevice)
									__int64 pPort,				// ˿ڵַ
									BYTE Value);			// д8λ

    BOOL DEVAPI FAR PASCAL PCIE9757_WritePortWord(HANDLE hDevice, __int64 pPort, WORD Value);
    BOOL DEVAPI FAR PASCAL PCIE9757_WritePortULong(HANDLE hDevice, __int64 pPort, ULONG Value);

    BYTE DEVAPI FAR PASCAL PCIE9757_ReadPortByte(HANDLE hDevice, __int64 pPort);
    WORD DEVAPI FAR PASCAL PCIE9757_ReadPortWord(HANDLE hDevice, __int64 pPort);
    ULONG DEVAPI FAR PASCAL PCIE9757_ReadPortULong(HANDLE hDevice, __int64 pPort);
	// Ҫûģʽ£ֱӷӲ˿ڣ밲װʹISA\CommUserµReadPortByteExȺ

	//########################### Ӳ ######################################
	HANDLE DEVAPI FAR PASCAL PCIE9757_CreateSystemEvent(void); // ں¼󣬹InitDeviceDmaADVB̵߳Ⱥʹ
	BOOL DEVAPI FAR PASCAL PCIE9757_ReleaseSystemEvent(HANDLE hEvent); // ͷں¼

#ifdef __cplusplus
}
#endif

//***********************************************************
// FIFO洢ĳ()
const long FIFO_IDT7202_LENGTH			= 1024;
const long FIFO_IDT7203_LENGTH			= 2048;
const long FIFO_IDT7204_LENGTH			= 4096;
const long FIFO_IDT7205_LENGTH			= 8192;
const long FIFO_IDT7206_LENGTH			= 16384;
const long FIFO_IDT7207_LENGTH			= 32768;

// Զ
#ifndef _PCIE9757_DRIVER_
	#ifndef _WIN64
		#pragma comment(lib, "PCIE9757_32.lib")
		#pragma message("======== Welcome to use our art company's products!")
		#pragma message("======== Automatically linking with PCIE9757_32.dll...")
		#pragma message("======== Successfully linked with PCIE9757_32.dll")
	#else
		#pragma comment(lib, "PCIE9757_64.lib")
		#pragma message("======== Welcome to use our art company's products!")
		#pragma message("======== Automatically linking with PCIE9757_64.dll...")
		#pragma message("======== Successfully linked with PCIE9757_64.dll")
	#endif
#endif

#endif // _PCIE9757_DEVICE_